#include <GL/glut.h>
#include <stdlib.h>
#include <iostream.h>
#include "Polygon.h"

#define ESC 27 //Application will exit on KEY_DOWN of ESC key

static GLboolean dragMouse = GL_FALSE; 
static GLboolean lastVertex = GL_FALSE; 

/*Mouse's coordinates here*/
static int mousex, mousey;
int height;
static GLboolean DONE = GL_FALSE;
 
Polygon p;

/*callback used for tracking Keyboard events*/
void keyboard(unsigned char key, int x, int y)
{
	/*The mouse position when the ESC key 
					is down doesnt matter*/
	if (key == ESC)
		exit(0);
}

/*callback used for adjusting the viewability*/
void reshape(int w, int h) {
  glViewport(0,0, w,h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0,w, h,0, -1,1);
  height = h;
}

void display(void) {  
  glClear(GL_COLOR_BUFFER_BIT);	/* clear offscreen buffer */
  glColor3f(1.0, 1.0, 1.0); /*White*/
  
  /*Join the polygons borders with white lines*/
  glBegin(GL_LINE_STRIP);
  for (int i = 0; i < p.numVerts; i++)
	glVertex2f(p.verts[i].x, p.verts[i].y);
  glEnd();
   
  /*If mouse's right button clicked fill the polygon
	by calling it scanfill method */
	if (lastVertex){ 		
		glBegin(GL_LINES);
	    glVertex2f(p.verts[0].x, p.verts[0].y);
		glVertex2f(p.verts[p.numVerts - 1].x, p.verts[p.numVerts - 1].y);
		glEnd();
		p.scanFill();
  
	}  
	glutSwapBuffers();  /* swap offscreen/display buffer (flushes GL commands) */
}

void mouse(int button, int state, int x, int y){

	if(DONE == GL_TRUE)
		return;
	if (button == GLUT_LEFT_BUTTON){
		if (state == GLUT_DOWN ){
			dragMouse = GL_TRUE;
			mousex = x;
			mousey = y;
		}else if (state == GLUT_UP && dragMouse){
			//if (p.numVerts < MAX_VERTS){
				p.verts[p.numVerts].x = (GLfloat) mousex;
				p.verts[p.numVerts].y = (GLfloat) mousey;
				p.numVerts++;				
			//}      
			dragMouse = GL_FALSE;
			lastVertex = GL_FALSE;
			glutPostRedisplay();   /* request a redisplay */
		}
	}else if (button == GLUT_RIGHT_BUTTON){
		if (state == GLUT_DOWN){
			lastVertex = GL_TRUE;
			DONE = GL_TRUE;
			glutPostRedisplay();
		}
	}

}

void mouseMotion(int x, int y) {
  if (dragMouse) {
    mousex = x;
    mousey = y;  
    glutPostRedisplay();  /* request a redisplay */      
  }
}



int main(int argc, char *argv[]) {  
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE); /* double buffer */
  glutInitWindowSize(640,480);
  glutInitWindowPosition(10,10);
  glutCreateWindow("Improved Polyline Editor");
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutMotionFunc(mouseMotion);
  glutKeyboardFunc(keyboard);
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glutMainLoop();
  return 0;
}

